<?php

namespace MSDev\MSClientAPI;

use MSDev\MSLib\FMConnector;
use MSDev\MSLib\FMException;

class ClientList {
	
	/**
	 * Dependancy container
	 * @var object
	 */
	protected $env;

	public function LocateClients($env, $req) {
		$this->env 		= $env;
		$page			= isset($req['page']) && is_numeric($req['page']) ? $req['page'] : 0;
		$clients 		= $this->loadClients($page);

		/** @var RequestResponse $resp */
		$resp			= $this->env->get('rr');
		return $resp->respond('Clients', $clients);
	}
	
	
	private function loadClients($page) {
		$setSize		= $this->env->get('SetSize');
		$start			= $page == 0 ? 0 : $page * $setSize;
		try {
		    /** @var FMConnector $fm */
			$fm 		= $this->env->get('fm');
			return $fm->selectAll(
				$this->env->get('UserLayout'),
				$start,
				$setSize,
				array(
					'ids' => false,
				)
			);
		} catch(FMException $e) {
			$id			= $e->getFMCode() == 401 ? 404 : 500;
			throw new \Exception($e->getFMError(), $id);
		}
	}
	
}