<?php

namespace MSDev\MSClientAPI;

use MSDev\MSLib\FMException;
use MSDev\MSLib\FMConnector;
use MSDev\MSClientAPI\Client;

class ClientPut extends Client {

	public function UpdateClient($env, $req) {
		$this->env 		= $env;

		$rr				= $this->env->get('rr');	
		$data			= $rr->cleanData($rr->getData());
		$recID			= $this->checkForUser($req['id']);
	
		$client 		= $this->doUpdate($recID, $data);

		return $rr->respond('Client', $client);
	}

	
	private function doUpdate($recID, $data) {
		try {
			$fm 		= $this->env->get('fm');
			$client		= $fm->update(
				$this->env->get('UserLayout'),
				$recID,
				$data,
				FMConnector::FM_RECORD
			);
	
			// clear the system IDs
			unset($client[0][FMConnector::FM_RECORD_ID]);
			unset($client[0][FMConnector::FM_MOD_ID]);
			
			return $client[0];
		} catch(FMException $e) {
			$id			= $e->getFMCode() == 401 ? 404 : 500;
			throw new \Exception($e->getFMError(), $id);
		}
	}
}