<?php

namespace MSDev\MSClientAPI;

class RSAEncryption {
	
	/**
	 * Dependancy container
	 * @var object
	 */
	protected $env;
	
    public function SignRequest($env) {
		$this->env 		= $env;

		/** @var RequestResponse $rr */
		$rr				= $this->env->get('rr');
		$data           = $rr->getData();

        if(empty($data['input']) || empty($data['key']) || empty($data['algorithm'])) {
            throw new \Exception('You must provide an input to sign, the key to sign it with and the algorithm to use.', 400);
        }

        $privateKey = str_replace('\n', "\n", $data['key']);
        $pass = empty($data['passphrase']) ? "" : $data['passphrase'];
        $key = openssl_pkey_get_private($privateKey, $pass);

        $binary_signature = "";
        openssl_sign($data['input'], $binary_signature, $key, $data['algorithm']);
        $sigString = $this->urlSafeB64Encode($binary_signature);

		return $rr->respond('Signature', $sigString);
	}

    public function urlSafeB64Encode($data)
    {
        $b64 = base64_encode($data);
        $b64 = str_replace(
            array('+', '/', '\r', '\n', '='),
            array('-', '_'),
            $b64
        );
        return $b64;
    }
}