<?php

namespace MSDev\MSRouter;

class Route extends \PHPRouter\Route {
	
	/**
	 * Accepted HTTP methods for this route.
	 *
	 * @var string[]
	 */
	private $methods = array('GET', 'POST', 'PUT', 'DELETE');
	
	public function __construct($resource, array $config)
	{
		$this->url     = $resource;
		$this->config  = $config;
		$this->methods = isset($config['methods']) ? $config['methods'] : array();
		$this->target  = isset($config['target'])  ? $config['target']  : null;
	}
	
	public function getUrl()
	{
		return $this->url;
	}
	
	public function getRegex()
	{
		return preg_replace_callback("/:(\w+)/", array(&$this, 'substituteFilter'), $this->url);
	}
	
	private function substituteFilter($matches)
	{
		if (isset($matches[1]) && isset($this->filters[$matches[1]])) {
			return $this->filters[$matches[1]];
		}
	
		return "([\w-%]+)";
	}
	
	public function getParameters()
	{
		return $this->parameters;
	}
	
	public function setParameters(array $parameters)
	{
		$this->parameters = $parameters;
	}
	
	public function dispatch($env)
	{
		$action = explode('::', $this->config['_controller']);
		$instance = new $action[0];
		$func = $action[1];
		
		$instance->$func($env, $this->parameters);
	}
	
}